/*
 * Copyright (C) 2004  Heinz Mauelshagen, Red Hat GmbH. All rights reserved.
 *
 * This dmraid code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * dmraid is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this dmraid library; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA
 */

#include <paths.h>
#include "internal.h"
#include "misc.h"

/*
 * OUCH (nasty hack).
 *
 * Need to open /dev/hd? in turn in order to
 * populate /sys/block in case of IDE module !?
 */
void sysfs_workaround(struct lib_context *lc)
{
	int d, fd;
	size_t len;
	char *dev;

	if ((dev = dbg_malloc(sizeof(_PATH_DEV) + 3)))
		sprintf(dev, "%shd?", _PATH_DEV);
	else
		LOG_ERR(, "sysfs workaround");

	for (len = strlen(dev) - 1, d = 'a'; d <= 'z'; d++) {
		dev[len] = (char) d;
		if ((fd = open (dev, O_RDONLY)) != -1)
			close (fd);
	}

	dbg_free(dev);
}
